#include "stdafx.h"

#include "cplx_GSL.h"
char* theLIB = "gsl.dll";

/* 
	to do: 
	- 1 call for the lib as an init & a gloabal var for it
	- and 1 to free it (both returning 0 / 1 for no / success
	- version
*/
   

/**********************************************************************
 * real arguments, real results, no wrapper need in Maple
 **********************************************************************/

/*
double __stdcall
double_gslFct_double1(char* fctname, double x1)
{
	double_fct_double1 tmpfct;
	double dummy;

	HINSTANCE hLib=LoadLibrary(theLIB);

	if(hLib==NULL) {
		return(error_double);
  }

	tmpfct = (double_fct_double1)GetProcAddress((HMODULE)hLib, fctname);

	if((tmpfct==NULL)) {
		FreeLibrary((HMODULE)hLib);
		return(error_double);
	}

	dummy = tmpfct(x1);

	FreeLibrary((HMODULE)hLib);

	return(dummy);
}

double __stdcall
double_gslFct_double2(char* fctname, double x1, double x2)
{
	double_fct_double2 tmpfct;
	double dummy;

	HINSTANCE hLib=LoadLibrary(theLIB);
	if(hLib==NULL) {return(error_double);}

	tmpfct = (double_fct_double2)GetProcAddress((HMODULE)hLib, fctname);
	if((tmpfct==NULL)) {FreeLibrary((HMODULE)hLib);return(error_double);}

	dummy = tmpfct(x1,x2);
	FreeLibrary((HMODULE)hLib);
	return(dummy);
}
*/
/**********************************************************************
 * real arguments, complex results
 **********************************************************************/

complex __stdcall
complex_gslFct_double1(char* fctname, double x1)
{
	gsl_complex_fct_double1 tmpfct;
	complex dummy;

	//gsl_complex w1;
	//GSL_SET_COMPLEX (&w1, z1.re, z1.im);

	HINSTANCE hLib=LoadLibrary(theLIB);
	if(hLib==NULL) {FreeLibrary((HMODULE)hLib);return(error_complex);}

	tmpfct = (gsl_complex_fct_double1)GetProcAddress((HMODULE)hLib, fctname);
	if((tmpfct==NULL)) {FreeLibrary((HMODULE)hLib);return(error_complex);}

	dummy = gsl2wrap(tmpfct(x1));
	FreeLibrary((HMODULE)hLib);
	return(dummy);
}

/**********************************************************************
 * complex arguments, real results
 * real results are set complex, as the wrapper does not work otherwise
 **********************************************************************/

complex __stdcall
double_gslFct_complex1(char* fctname, complex z1)
{
	double_fct_gsl_complex1 tmpfct;
	complex dummy;

	gsl_complex w1;
	GSL_SET_COMPLEX (&w1, z1.re, z1.im);

	HINSTANCE hLib=LoadLibrary(theLIB);
	if(hLib==NULL) {FreeLibrary((HMODULE)hLib);return(error_complex);}

	tmpfct = (double_fct_gsl_complex1)GetProcAddress((HMODULE)hLib, fctname);
	if((tmpfct==NULL)) {FreeLibrary((HMODULE)hLib);return(error_complex);}

	dummy.re = tmpfct(w1);
	dummy.im = 0.0;
	FreeLibrary((HMODULE)hLib);
	return(dummy);
}

/**********************************************************************
 * complex arguments, complex results
 **********************************************************************/

complex __stdcall
complex_gslFct_complex1(char* fctname, complex z1)
{
	gsl_complex_fct_gsl_complex1 tmpfct;
	complex dummy;

	gsl_complex w1;
	GSL_SET_COMPLEX (&w1, z1.re, z1.im);

	HINSTANCE hLib=LoadLibrary(theLIB);
	if(hLib==NULL) {FreeLibrary((HMODULE)hLib);return(error_complex);}

	tmpfct = (gsl_complex_fct_gsl_complex1)GetProcAddress((HMODULE)hLib, fctname);
	if((tmpfct==NULL)) {FreeLibrary((HMODULE)hLib);return(error_complex);}

	dummy = gsl2wrap(tmpfct(w1));
	FreeLibrary((HMODULE)hLib);
	return(dummy);
}

complex __stdcall
complex_gslFct_complex2(char* fctname, complex z1, complex z2)
{
	gsl_complex_fct_gsl_complex2 tmpfct;
	complex dummy;

	gsl_complex w1,w2;
	GSL_SET_COMPLEX (&w1, z1.re, z1.im);
	GSL_SET_COMPLEX (&w2, z2.re, z2.im);

	HINSTANCE hLib=LoadLibrary(theLIB);
	if(hLib==NULL) {FreeLibrary((HMODULE)hLib);return(error_complex);}

	tmpfct = (gsl_complex_fct_gsl_complex2)GetProcAddress((HMODULE)hLib, fctname);
	if((tmpfct==NULL)) {FreeLibrary((HMODULE)hLib);return(error_complex);}

	dummy = gsl2wrap(tmpfct(w1,w2));
	FreeLibrary((HMODULE)hLib);
	return(dummy);
}