#include "stdafx.h"

#include "cplx_GSL.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <maplec.h>
#include <mplshlib.h>
#include <mpltable.h>

MKernelVector mapleKernelVec;
typedef void *MaplePointer;
ALGEB *args;

ALGEB mwarp__complex_gslFct_double1( MKernelVector kv, ALGEB fn_args )
{
    char *a1;
    FLOAT64 a2;
    complex r; //ComplexFloat64 r;
		ALGEB mr;
    //int i;

    mapleKernelVec = kv;
    args = (ALGEB*) fn_args;

    if( MapleNumArgs(mapleKernelVec,(ALGEB)args) != 2 )
        MapleRaiseError(mapleKernelVec,"Incorrect number of arguments");

    /* string[] */
    a1 = MapleToString(mapleKernelVec,MapleEval(mapleKernelVec,args[1]));

    /* float[8] */
    a2 = MapleToFloat64(mapleKernelVec,args[2]);

    r = complex_gslFct_double1(a1, a2);

    mr = ToMapleComplex(mapleKernelVec,(double)r.re,(double)r.im);
    return( mr );
}


/* 
	returns complex, not double !! 
	else i did not get the wrapper to work 
*/
ALGEB mwarp__double_gslFct_complex1( MKernelVector kv,	ALGEB fn_args )
{
    char *a1;
    complex a2; //ComplexFloat64 a2;
    complex r;  //ComplexFloat64 r;
    ALGEB mr;
    //int i;

    mapleKernelVec = kv;
    args = (ALGEB*) fn_args;

    if( MapleNumArgs(mapleKernelVec,(ALGEB)args) != 2 )
        MapleRaiseError(mapleKernelVec,"Incorrect number of arguments");

    /* string[] */
    a1 = MapleToString(mapleKernelVec,MapleEval(mapleKernelVec,args[1]));

    /* complex[8] */
    a2.im = MapleToFloat64(mapleKernelVec,MapleSelectImaginaryPart(mapleKernelVec,(ALGEB)(args[2])));
    a2.re = MapleToFloat64(mapleKernelVec,MapleSelectRealPart(mapleKernelVec,(ALGEB)(args[2])));

    r = double_gslFct_complex1(a1, a2);

    mr = ToMapleComplex(mapleKernelVec,(double)r.re,(double)r.im);
		//mr = ToMapleFloat(mapleKernelVec,r);
    return( mr );
}

ALGEB mwarp__complex_gslFct_complex1( MKernelVector kv, ALGEB fn_args )
{
    char *a1;
    complex a2; //ComplexFloat64 a2;
    complex r;  //ComplexFloat64 r;
    ALGEB mr;
    //int i;

    mapleKernelVec = kv;
    args = (ALGEB*) fn_args;

    if( MapleNumArgs(mapleKernelVec,(ALGEB)args) != 2 )
        MapleRaiseError(mapleKernelVec,"Incorrect number of arguments");

    /* string[] */
    a1 = MapleToString(mapleKernelVec,MapleEval(mapleKernelVec,args[1]));

    /* complex[8] */
    a2.im = MapleToFloat64(mapleKernelVec,MapleSelectImaginaryPart(mapleKernelVec,(ALGEB)(args[2])));
    a2.re = MapleToFloat64(mapleKernelVec,MapleSelectRealPart(mapleKernelVec,(ALGEB)(args[2])));

    r = complex_gslFct_complex1(a1, a2);

    mr = ToMapleComplex(mapleKernelVec,(double)r.re,(double)r.im);
    return( mr );
}

ALGEB mwarp__complex_gslFct_complex2( MKernelVector kv, ALGEB fn_args )
{
    char *a1;
    complex a2; //ComplexFloat64 a2;
    complex a3; //ComplexFloat64 a3;
    complex r;  //ComplexFloat64 r;
    ALGEB mr;
    //int i;

    mapleKernelVec = kv;
    args = (ALGEB*) fn_args;

    if( MapleNumArgs(mapleKernelVec,(ALGEB)args) != 3 )
        MapleRaiseError(mapleKernelVec,"Incorrect number of arguments");

    /* string[] */
    a1 = MapleToString(mapleKernelVec,MapleEval(mapleKernelVec,args[1]));

    /* complex[8] */
    a2.im = MapleToFloat64(mapleKernelVec,MapleSelectImaginaryPart(mapleKernelVec,(ALGEB)(args[2])));
    a2.re = MapleToFloat64(mapleKernelVec,MapleSelectRealPart(mapleKernelVec,(ALGEB)(args[2])));

    /* complex[8] */
    a3.im = MapleToFloat64(mapleKernelVec,MapleSelectImaginaryPart(mapleKernelVec,(ALGEB)(args[3])));
    a3.re = MapleToFloat64(mapleKernelVec,MapleSelectRealPart(mapleKernelVec,(ALGEB)(args[3])));

    r = complex_gslFct_complex2(a1, a2, a3);

    mr = ToMapleComplex(mapleKernelVec,(double)r.re,(double)r.im);
    return( mr );
}